/* $XFree86: xc/programs/Xserver/hw/xfree86/os-support/xf86drmSavage.h,v 3.3 2001/10/31 $ */

/* WARNING: If you change any of these defines, make sure to change
 * the kernel include file as well (savage_drm.h)
 */

#ifndef _XF86DRI_SAVAGE_H_
#define _XF86DRI_SAVAGE_H_

#ifndef _SAVAGE_DEFINES_
#define _SAVAGE_DEFINES_
#define SAVAGE_USE_BATCH 1

#define SAVAGE_DMA_BUF_ORDER     12
#define SAVAGE_DMA_BUF_SZ        (1<<SAVAGE_DMA_BUF_ORDER)
#define SAVAGE_DMA_BUF_NR        256

#define SAVAGE_NR_SAREA_CLIPRECTS 8

/* Each region is a minimum of 64k, and there are at most 64 of them.
 */
#define SAVAGE_NR_TEX_REGIONS 64
#define SAVAGE_LOG_MIN_TEX_REGION_SIZE 16
#endif

typedef struct _drmSAVAGEInit {
   unsigned int start; 
   unsigned int end; 
   unsigned int size;
   unsigned int mmio_offset;
   unsigned int buffers_offset;
   int sarea_off;

   unsigned int front_offset;
   unsigned int back_offset;
   unsigned int depth_offset;
   unsigned int w;
   unsigned int h;
   unsigned int pitch;
   unsigned int pitch_bits;
} drmSAVAGEInit;


Bool drmSAVAGECleanupDma(int driSubFD);
Bool drmSAVAGEInitDma(int driSubFD, drmSAVAGEInit *info );

#endif
