#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/mman.h>
#include <sys/stat.h>
#include <stdio.h>
#include <string.h>

#include <unistd.h>

#define MAX_LENGTH 20
struct pattern{
    char key[MAX_LENGTH];
    int size;
};

struct pattern P[]={{"/*@*/",5},{"",0}};

int modify_a_file(char*,char *,struct pattern *);

int main(int argc,char**argv)
{
    return modify_a_file(argv[1],argv[2],P);
    
}

int modify_a_file(char* infile,char *outfile,struct pattern *p)
{
    int infd,outfd;
    struct stat instat;
    int i;
    char * inmap;
    struct pattern *q,*current_match;
    
    if ((infd = open(infile,O_RDONLY))<= 0)
    {
        printf("Open file %s Error!\n",infile);
        return 0;
    }
    if ((outfd = open(outfile,O_RDWR|O_CREAT))<=0 )
    {
        printf("Open file %s Error!\n",outfile);
        return 0;
    }
    fstat(infd,&instat);
    inmap = (char *)mmap(NULL,instat.st_size,PROT_READ,MAP_PRIVATE,infd,0);

    current_match = NULL;
    for (i=0;i<instat.st_size;i++)
    {
        q=p;
     
        if (!current_match)
        {
            while(q->size)
            {
                if (!strncmp(&inmap[i],q->key,q->size))
                {
                    /*found the begin*/
                    current_match = q;
                    break;
                }
                q++;
            }
        }
        else
        {
            if (!strncmp(&inmap[i],current_match->key,current_match->size))
            {
                /* find the end*/
                i+=current_match->size-1;
                current_match = NULL;
                continue;
            }
        }
                    
                    
        if (!current_match)
        {
            /* write to ourfile*/
            if ( write(outfd,&inmap[i],1)!= 1)
            {
                printf("Write file %s error !",outfile);
                return 0;
            }

        }
    }


    close(infd);
    close(outfd);
    return 1;
}
    
    
